#ifndef __LL__
#define __LL__

typedef struct __tagNODE
{
  struct __tagNODE *pNext;
} NODE,*LPNODE;

typedef void (*NODEFREEFUNC)(LPNODE pNode);

typedef struct __tagLIST
{
  LPNODE pHead;
  LPNODE pTail;
  NODEFREEFUNC pFree;
  unsigned int uCount;
} LIST,*LPLIST;

LPLIST ListCreate(NODEFREEFUNC pFree,size_t objSize);
LPNODE ListCreateNode(LPLIST pList,size_t objSize);
void ListAddTail(LPLIST pList,LPNODE pNode);
void ListDestroy(LPLIST pList);

#endif
